import linuxcnc
import os
import hal
import hal_glib
import gtk

class HandlerClass:

    def __init__(self, halcomp,builder,useropts):
        jog_x_active_pin = halcomp.newpin('jog_x_active_pin',hal.HAL_BIT, hal.HAL_OUT)
        jog_y_active_pin = halcomp.newpin('jog_y_active_pin',hal.HAL_BIT, hal.HAL_OUT)
        jog_z_active_pin = halcomp.newpin('jog_z_active_pin',hal.HAL_BIT, hal.HAL_OUT)
        jog_a_active_pin = halcomp.newpin('jog_a_active_pin',hal.HAL_BIT, hal.HAL_OUT)
        self.builder = builder
	self.halcomp = halcomp

    def on_jog_x_clicked(self,widget,data=None):
        self.builder.get_object('jog_off_led').set_active(False)	
        self.builder.get_object('jog_y_active').set_active(False)	
        self.builder.get_object('jog_z_active').set_active(False)	
        self.builder.get_object('jog_a_active').set_active(False)	
        self.builder.get_object('jog_x_active').set_active(True)	
        self.builder.get_object('hal_dro1').joint_number = 0
        self.builder.get_object('dro').set_label('X Axis:')
	self.halcomp["jog_y_active_pin"] = False
	self.halcomp["jog_z_active_pin"] = False
	self.halcomp["jog_a_active_pin"] = False
	self.halcomp["jog_x_active_pin"] = True

    def on_jog_y_clicked(self,widget,data=None):
        self.builder.get_object('jog_off_led').set_active(False)	
        self.builder.get_object('jog_x_active').set_active(False)	
        self.builder.get_object('jog_z_active').set_active(False)	
        self.builder.get_object('jog_a_active').set_active(False)	
        self.builder.get_object('jog_y_active').set_active(True)	
        self.builder.get_object('hal_dro1').joint_number = 1	
        self.builder.get_object('dro').set_label('Y Axis:')
	self.halcomp["jog_x_active_pin"] = False
	self.halcomp["jog_z_active_pin"] = False
	self.halcomp["jog_a_active_pin"] = False
	self.halcomp["jog_y_active_pin"] = True

    def on_jog_z_clicked(self,widget,data=None):
        self.builder.get_object('jog_off_led').set_active(False)	
        self.builder.get_object('jog_x_active').set_active(False)	
        self.builder.get_object('jog_y_active').set_active(False)	
        self.builder.get_object('jog_a_active').set_active(False)	
        self.builder.get_object('jog_z_active').set_active(True)	
        self.builder.get_object('hal_dro1').joint_number = 2
        self.builder.get_object('dro').set_label('Z Axis:')
	self.halcomp["jog_x_active_pin"] = False
	self.halcomp["jog_y_active_pin"] = False
	self.halcomp["jog_a_active_pin"] = False
	self.halcomp["jog_z_active_pin"] = True


    def on_jog_a_clicked(self,widget,data=None):
        self.builder.get_object('jog_y_active').set_active(False)	
        self.builder.get_object('jog_z_active').set_active(False)	
        self.builder.get_object('jog_x_active').set_active(False)	
        self.builder.get_object('jog_a_active').set_active(True)	
        self.builder.get_object('hal_dro1').joint_number = 3
        self.builder.get_object('dro').set_label('A Axis:')
	self.halcomp["jog_x_active_pin"] = False
	self.halcomp["jog_y_active_pin"] = False
	self.halcomp["jog_z_active_pin"] = False
	self.halcomp["jog_a_active_pin"] = True

    def on_jog_off_clicked(self,widget,data=None):
        self.builder.get_object('jog_off_led').set_active(True)	
        self.builder.get_object('jog_x_active').set_active(False)	
        self.builder.get_object('jog_z_active').set_active(False)	
        self.builder.get_object('jog_a_active').set_active(False)	
        self.builder.get_object('jog_y_active').set_active(False)	
        self.builder.get_object('hal_dro1').joint_number = -1
        self.builder.get_object('dro').set_label('- Axis:')
	self.halcomp["jog_x_active_pin"] = False
	self.halcomp["jog_y_active_pin"] = False
	self.halcomp["jog_z_active_pin"] = False
	self.halcomp["jog_a_active_pin"] = False


        # hal pin with change callback.
        # When the pin's value changes the callback is executed.
        #self.max_value = hal_glib.GPin(halcomp.newpin('max-value',  hal.HAL_FLOAT, hal.HAL_IN))
        #self.max_value.connect('value-changed', self._on_max_value_change)

        #inifile = linuxcnc.ini(os.getenv("INI_FILE_NAME"))
        #mmin = float(inifile.find("METER", "MIN") or 0.0)
        #self.meter = self.builder.get_object('meter')
        #self.meter.min = mmin




def get_handlers(halcomp,builder,useropts):
    return [HandlerClass(halcomp,builder,useropts)]


